#!/bin/bash
clear
if [ -f /opt/seg/control_aula ]; then
{
echo "Atenció! ja havies configurat aquest equip!"
echo "Es continua la instal·lació amb al nova configuració en 3 segons, en cas contrari"
echo "Interrump amb CTRL+C"
echo ""
sleep 3
echo "Continuem!"
}
fi

echo "Directori on es deixen les copies dels fitxers modificats"
if [ ! -d /opt/seg ]; then
{
    mkdir -p /opt/seg
}
fi


## Llista de targetes de xarxa
LIST_DEV=`ip link sh | grep ^[0-9] | grep -v " lo" | cut -d":" -f 2 | tr -d " "`
DEVS=$(echo $LIST_DEV)
## Control d'errors
ERROR="1"
res=""


## Revisar valor de xarxa
check_ip()
{
echo "$2" | grep -E '^(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9])\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{
1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[0-9])$' > /dev/null 2>&1
if [ "$?" -gt 0 ]; then
        echo "Error, $1:$2 no és vàlid"
        sleep 3

        ERROR="1"
fi
}

## Revisar connexió
check_connexio()
{
sudo apt install -y hping3
sudo hping3 -S google.com -p 443 -c 4
if [ $? -eq 0 ]; then
        CONNEXIO="1"
else
        echo -en "Error de connexió: Reviseu la configuració de xarxa"
        exit 12
fi
sudo hping3 -S __IP_SERVER__ -c 4
if [ $? -eq 0 ]; then
        CONNEXIO="1"
else
        echo -en "Error de connexió: No sembla la IP del servidor"
        exit 12
fi
}

variables_lk(){
echo "Indica la IP del servidor: "
read __IP_SERVER__;
#check_ip
}

desbloca_repos(){
#check_connexio
killall update-manager update-notifier > /dev/null 2>&1
#rm /var/lib/dpkg/lock*
}


echo "Secció de muntatge"
munta_recursos(){
echo "Instala protocol"
echo "Funció per desblocar repos"
desbloca_repos 
echo "Instala dependencia del muntage"
apt-get update
apt-get install -y nfs-common autofs
if [ -f /etc/systemd/system/home.mount ]; then
{
mv /etc/systemd/system/home.mount /opt/seg
}
fi

echo "Creo els punts per les unitats de xarxa per autofs"
if [ ! -d /mnt/.nfs ]; then {
echo "Creo el directori pels muntatges que no existia"
mkdir -p /mnt/.nfs
} fi

#fitxer master que fa referencia al fitxer dels muntatges
echo "/mnt/.nfs  /etc/auto.nfs --timeout 30" >> /etc/auto.master
#punts de muntatges a la IP del servidor
echo "Professorat -fstype=nfs,soft,intr $__IP_SERVER__:/srv/exports/P" > /etc/auto.nfs
echo "Programari -fstype=nfs,soft,intr $__IP_SERVER__:/srv/exports/S" >> /etc/auto.nfs
echo "Treball -fstype=nfs,soft,intr $__IP_SERVER__:/srv/exports/T" >> /etc/auto.nfs
echo "Gestio -fstype=nfs,soft,intr $__IP_SERVER__:/srv/exports/G" >> /etc/auto.nfs
echo "Multimedia -fstype=nfs,soft,intr $__IP_SERVER__:/srv/exports/M" >> /etc/auto.nfs
#Enllaços visibles
ln -s /mnt/.nfs/Professorat /mnt/.
ln -s /mnt/.nfs/Programari  /mnt/.
ln -s /mnt/.nfs/Treball /mnt/.
ln -s /mnt/.nfs/Gestio /mnt/.
ln -s /mnt/.nfs/Multimedia /mnt/.

echo "Creo l'enllaç a l'escriptori de l'usuari"
cat <<EOF | tee /etc/xdg/autostart/unitats.desktop
[Desktop Entry]
Version=1.0
Name=Unitats en els escriptoris
Exec=ln -s /mnt/.nfs/ ~/Escriptori/Unitats
EOF

}


loginManual(){
#Editem el fitxer de sel.lecció d'usuari
cat <<EOF | tee /etc/lightdm/lightdm.conf.d/10-loginmanual.conf
 [SeatDefaults]
  greeter-hide-users=true
  greeter-show-manual-login=true
EOF
}

connectaLDAP(){
##Instal.lem i configurarem els serveis client LDAP ( atenció a  ldap://IPSERVIDOR i a les caselles a marcar).
check_connexio
apt-get install -y libpam-ldapd libnss-ldapd nss-updatedb libnss-db nscd nslcd ldap-utils
#Apliquem canvis
pam-auth-update
clear;
echo "Continuem permissos i reiniciant";
sleep 2;
#Asignem permissos de grups locals als nous usuaris de domini
echo "*;*;*;Al0000-2400;audio,cdrom,dialout,floppy" >> /etc/security/group.conf

# Crem el fitxer pel modul de grup PAM
cat <<EOF | tee /usr/share/pam-configs/my_groups
 Name: activate /etc/security/group.conf
 Default: yes
 Priority: 900
 Auth-Type: Primary
 Auth:
 Auth-Type: Primary
 required pam_group.so use_first_pass
EOF

# Activem el canvi:
pam-auth-update
/etc/init.d/nscd restart

}


clear
echo "Comença la instal·lació"
variables_lk
munta_recursos
loginManual
connectaLDAP

touch /opt/seg/control_aula

echo ""
echo ""
echo "Script finalitzat, reinicieu aquest equip manualment"
echo ""
echo ""
