#!/bin/bash
if [ ! -d /opt/configuracio ]; then 
{
    echo "No existeix el directori de configuracio, el crearem"
    mkdir -p /opt/configuracio
}
fi

LOG_FILE=/opt/configuracio/Control_Linkdows22.log

esRoot() {

   if [ $(/usr/bin/id -u) -ne 0 ]; then
    {
      echo "No ets root, es surt del programa" 2> /dev/null
      exit 1
    }
    fi
}

iniciLog() {

  echo "$(date +%F--%T) - #### INICIA $1 ####" >> $LOG_FILE

}


finalLog() {

  echo "$(date +%F--%T) - #### FINALITZA $1 ####" >> $LOG_FILE
  echo "$(date +%F--%T) -" >> $LOG_FILE

}

comprovaErrades() {
  if [ $? -ne 0 ]; then
      echo "Si que ha hagut errades mira $LOG_FILE per detalls."
  else
      echo "Funció aplicada amb èxit, pots revisar $LOG_FILE."
  fi
}

aplicacions() {
    echo "Instal·lem aplicacions interesants per un equip d'alumne"
    apt install -y linkat-congela-escriptori linkat-conky-conf-edc
}

TTF_Win() {
    echo "Descarrego i aplico les Fonts Tipografiques"
    wget https://mainkivi.info/scripts/fonts.tar.gz
    tar xzvf  fonts.tar.gz -C /usr/share/
    rm fonts.tar.gz
    chown -R root:root /usr/share/fonts
    chmod 775 -R /usr/share/fonts
}

Icones_Win() {
    echo "Descarrego les icones oficias de Win10"
    if [ -d /usr/share/icons/Windows-10-master ]
    then 
        echo "Ja estàn descarregades les icones, no cal tornar a fer-ho"
    else
        echo "Descarreguem les icones"
        sleep 2
        wget https://github.com/B00merang-Project/Windows-10-Icons/archive/master.zip
        unzip master.zip
        rm master.zip
        mv Windows-10-master /usr/share/icons/
        echo "Icones Descarregades"
    fi
}

PerfilLinkdows() {
    echo "Descarrego la configuracio per Mate"
    wget https://mainkivi.info/scripts/perfilLinkdows/linkdows22.conf
    mv linkdows22.conf /opt/configuracio/

    echo "Fem el script"

    echo "#!/bin/bash " > /usr/local/bin/perfilLinkdows
    echo "dconf dump / > ~/LaMevaConfiguracio.conf" >> /usr/local/bin/perfilLinkdows
    echo "dconf load / < /opt/configuracio/linkdows22.conf" >> /usr/local/bin/perfilLinkdows
    echo "exit" >> /usr/local/bin/perfilLinkdows

    echo "I el fem executable"

    chmod 775 /usr/local/bin/perfilLinkdows
}


##Comença la instalació 
esRoot 

iniciLog "---- SCRIPT ----"
#
##Executo la funció

aplicacions >> $LOG_FILE 2> /dev/null
comprovaErrades >> $LOG_FILE

TTF_Win >> $LOG_FILE 2> /dev/null
comprovaErrades >> $LOG_FILE

Icones_Win >> $LOG_FILE 2> /dev/null
comprovaErrades >> $LOG_FILE

PerfilLinkdows >> $LOG_FILE 2> /dev/null
comprovaErrades >> $LOG_FILE


finalLog "---- SCRIPT ----"

clear
echo "=============================================================================="
echo "=============================================================================="
echo "======================================================================="
echo "El perfil ja es pot aplicar, només cal executar en executar en consola:"
echo ""
echo "perfilLinkdows"
echo ""
echo "Atenció a les majúscules!!"
echo "======================================================================="
echo ""
echo "Pren la telca de Retorn per continuar"
echo "=============================================================================="
echo "=============================================================================="
read foo;

exit $?


